<script lang="ts">
  import { onMount } from "svelte";
  import { inputPattern } from "src/functions/input-pattern";
  import type { UserFormModel } from "src/models/user.form.type";
  import AlertConfirm from "src/widgets/AlertConfirm";
  import AlertMessage from "src/widgets/AlertMessage";
  import Pagination from "src/widgets/Pagination.svelte";
  import {
    formViewMode,
    pageSelectedStore,
    userDataListStore,
    userFormRegisStore,
  } from "src/store";
  import type { UserDataModel } from "src/models/user.auth.type";
  import Fa from "svelte-fa";
  import { faEdit, faSearch, faTrash } from "@fortawesome/free-solid-svg-icons";
  import { Page } from "src/page";
  import { deleteUserProfileAPI } from "src/apis/delete-user-profile";
  import { getUserListAPI } from "src/apis/get-users";
  let usersProfilePagination: UserFormModel[] = [];

  let keyWord = "";
  let respSearch: UserFormModel[] = [];
  let addressFindText = "";
  let searchPattern: any = {
    [`รหัส`]: "userId",
    [`ชื่อ`]: "fname",
    [`สกุล`]: "lname",
    [`อีเมลล์`]: "email",
    [`เบอร์`]: "telNo",
  };

  let searchBy = "รหัส";
  let dataShowOnTable: UserFormModel[] = [];

  onMount(async () => {
    await getUserListAPI();
  });

  $: {
    dataShowOnTable =
      respSearch.length && (keyWord || addressFindText)
        ? respSearch
        : keyWord == "" && addressFindText == ""
        ? usersProfilePagination
        : [];
  }

  function findDataArray() {
    if (keyWord) {
      keyWord = keyWord.replace(/\\/g, "");
      let regex = new RegExp(keyWord, "g");
      respSearch = $userDataListStore.filter((dt: any) => {
        if (dt[searchPattern[searchBy]]) {
          return dt[searchPattern[searchBy]].replace(/-/g, "").match(regex);
        }
      });
    } else {
      respSearch = [];
    }
  }
</script>

<div class="rounded h-full m-4">
  {#if $userDataListStore.length > 0}
    <div id="tools" class="bg-gray-800 p-2 rounded">
      <div class="flex flex-wrap -mx-3 mb-2 justify-end items-center">
        <p class="text-white">ค้นหาโดย :</p>
        <div class="w-full md:w-1/6 px-3 mb-6 md:mb-0">
          <div class="">
            <select
              bind:value={searchBy}
              class="block w-full bg-gray-200 border
              border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight
              focus:outline-none focus:bg-white focus:border-gray-500"
              id="grid-state"
            >
              {#each Object.keys(searchPattern) as k}
                <option>{k}</option>
              {/each}
            </select>
          </div>
        </div>

        <div class="w-full md:w-3/6 px-3 mb-6 md:mb-0">
          <input
            bind:value={keyWord}
            on:keyup={() => findDataArray()}
            placeholder="ค้นหา"
            class="appearance-none block w-full py-3 px-4 leading-tight
            text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
            focus:border-gray-500 rounded focus:outline-none pac-target-input"
          />
        </div>
      </div>
      {#if respSearch.length == 0 && (keyWord || addressFindText)}
        <p class="text-right px-2 text-red-500">* ไม่พบรายการบนฐานข้อมูล</p>
      {/if}
    </div>
    <div class="w-full">
      <table
        class="table-auto w-full overflow-y-auto overflow-x-auto border rounded"
      >
        <thead class="bg-gray-100">
          <tr>
            <th class="px-4 py-2">#</th>
            <th class="px-4 py-2">รหัส</th>
            <th class="px-4 py-2">ชื่อ</th>
            <th class="px-4 py-2">สกุล</th>
            <th class="px-4 py-2">อีเมลล์</th>
            <th class="px-4 py-2">วันเกิด</th>
            <th class="px-4 py-2">เบอร์ติดต่อ</th>
          </tr>
        </thead>
        {#each dataShowOnTable as profile, index}
          <tbody>
            <tr class="bg-gray-100 hover:bg-gray-200">
              <td class="border px-4 py-2 text-gray-800">{index + 1}</td>
              <td class="border px-4 py-2 text-gray-800">{profile.userId}</td>
              <td class="border px-4 py-2 text-gray-800">{profile.fname}</td>
              <td class="border px-4 py-2 text-gray-800">{profile.lname}</td>
              <td class="border px-4 py-2 overflow-x-hidden text-gray-800">
                {profile.email || "-"}
              </td>
              <td class="border px-4 py-2 text-gray-800">
                {profile.birth || "-"}
              </td>
              <td class="border px-4 py-2 text-gray-800">
                {profile.telNo || "-"}
              </td>
            </tr>
          </tbody>
        {/each}
      </table>
    </div>
    <Pagination
      maxItemPerPage={10}
      bind:items={$userDataListStore}
      bind:pageItemsCurrent={usersProfilePagination}
    />
  {:else}
    <div class="h-full flex justify-center items-center">
      <p class="text-gray-500 text-xl text-right">
        ไม่พบรายการบนฐานข้อมูล
        <br />
        กรุณาเพิ่มข้อมูลประวัติก่อน
      </p>
    </div>
  {/if}
</div>
